;//	LZE DECODE ROUTINE
;//	Original Copyright (C)1995,2008 GORRY.
;//	Porting for SC61860 by Kei Moroboshi 2020/May
LZEPtr		EQU	04H	;XL,XH
DISTANCE	EQU	08H	;K,L
COPYCOUNT	EQU	0AH	;M

;	PUBLIC	DECODE_LZE
;==============================================================================
;LZE data decoder
;input:
;	DP	Top address of src(word),dst(word) table.
;src(word),dst(word) table:
;	DW	LZE encoded data address -1 (*1)(*2)
;	DW	extracting address -1 (*2)
;(*1)lze.exe add 4 byte header as extracted size(big-endian).
;Therefore, you must set src as LZE data top + 4(skip the header).
;(*2) IXL and IYS are PRE-INCREMENT instruction of SC61860.
;So you have to decrement beforehand each other.
;Broken:
;	P,Q,I,A,XL,XH,YL,YH,K,L,M
;Example:
;START:	LIDP	SDDW
;	CALL	DECODE_LZE
;	...
;SDDW:	DW	LZEDAT+4-1	;X:<<<MUST +4 -1
;	DW	DST-1		;Y:<<<MUST -1
;==============================================================================
DECODE_LZE:				;ENTRY
	LP	LZEPtr
	LII	4-1
	MVWD

	LII	1	;BitCount=1

STORE:	PUSH
	IXL		;*(DECODEPtr++) = *(LZEPtr++);
	IYS
	POP

MAINLP:
	DECI
	JRNZP	SKIP	;BitTest() {
	IXL
	LII	8
SKIP:	SL		;}

	JRCM	STORE

;Copy
	DECI		;BitTest() {
	JRNZP	SKIP0
	IXL
	LII	8
SKIP0:	SL		;}

	JRCP	COPYWD
;COPY with Byte Distance
COPYBD:
	DECI		;BitTest() {
	JRNZP	SKIP00	
	IXL
	LII	8
SKIP00:	SL		;}
	LP	COPYCOUNT
	ANIM	0
	JRNCP	NICC
	INCM
NICC:
	DECI		;BitTest() {
	JRNZP	SKIP01
	IXL
	LII	8
SKIP01:	SL		;}

	PUSH

	LP	COPYCOUNT
	LDM
	ADCM		;adc	CopyCount,CopyCount

	IXL		;LoadDistanceB();
			;Distance = -256+((int)*(LZEPtr++));
	LP	DISTANCE	;K
	EXAM
	LP	DISTANCE+1
	ORIM	0FFH
;
CPCNTP2:		;CopyCount ++;
	INCM		;inc	CopyCount
CPCNTP1:
	INCM		;inc	CopyCount
			;Copy() {
	;X:CopyPtr=KL:Distance + X:DECODEPtr
	LP	DISTANCE	;2
	LDM			;2
	LP	LZEPtr		;2
	EXAM			;3
	PUSH	;XL		;3
	ADM			;3
	LP	DISTANCE+1	;2
	LDM			;2
	LP	LZEPtr+1	;2
	EXAM			;3
	PUSH	;XH		;3
	ADCM			;3

LDIR:	IXL
	IYS
	DECM
	JRNZM	LDIR

	LP	LZEPtr+1	;2
	POP			;2
	EXAM			;3
	LP	LZEPtr		;2
	POP			;2
	EXAM			;3

	POP
	JRM	MAINLP

;Copy With Word Distance
COPYWD:	PUSH
	IXL	;A=DistanceH	;LoadDistanceW() {
	LP	DISTANCE+1
	EXAM
	IXL	;A=DistanceL
	PUSH
	EXAM
				;mov	CopyCount,Distance
	SR			;H shr	Distance,1
	EXAM
	SR			;L
	EXAM
	SR			;H shr	Distance,1
	EXAM
	SR			;L
	EXAM
	SR			;H shr	Distance,1
	EXAM
	SR			;L
	ORIM	0E0H		;or	DistanceH,0e0h
	LP	DISTANCE
	EXAM			;KL(Distance)=(Distance>>3) | 0xE000;

	POP
	LP	COPYCOUNT	;CopyCountL
	EXAM			;if ( (CopyCount &= 7) != 0 ) {
	ANIM	7		;  CopyCount += 2; Copy();
	JRNZM	CPCNTP2
 	IXL			;}else { // if CopyCount == 0
;	LP	COPYCOUNT	;  LoadCopyCount() {
	EXAM			; } C'=CopyCountL
	TSIM	0FFH		;if ( CopyCount==0 ) goto DECODE_END
	JRNZM	CPCNTP1
DECODE_END:
	POP
	RTN

